SystemOrganization addCategory: #'SqSync-Shared'!
SystemOrganization addCategory: #'SqSync-Client'!
SystemOrganization addCategory: #'SqSync-Server'!
SystemOrganization addCategory: #'SqSync-Tests'!
SystemOrganization addCategory: #'SqSync-Repository'!
SystemOrganization addCategory: #'SqSync-Tools'!
SystemOrganization addCategory: #SqSync!

!UndefinedObject methodsFor: '*SqSync' stamp: 'rkrk 6/13/2010 23:38:22.564'!
isNilOrTerminated

	^ true! !

ReferenceStream subclass: #SyReferenceMappingStream
	instanceVariableNames: 'mapping'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tools'!

!SyReferenceMappingStream class methodsFor: 'as yet unclassified' stamp: 'mt 6/15/2010 15:30:19.245'!
mapping: aSyReferenceMapping

	^ self
		on: (RWBinaryOrTextStream on: '')
		mapping: aSyReferenceMapping.! !

!SyReferenceMappingStream class methodsFor: 'as yet unclassified' stamp: 'mt 6/15/2010 15:30:10.363'!
on: stream	mapping: aSyReferenceMapping
	
	^ (self on: stream)
		mapping: aSyReferenceMapping;
		yourself.! !

!SyReferenceMappingStream class methodsFor: 'as yet unclassified' stamp: 'mt 6/15/2010 15:30:28.091'!
streamedRepresentationOf: anObject mapping: aSyReferenceMapping
	
	"copied from DataStream class >> #streamedRepresentationOf:"
	| file |
	file := (RWBinaryOrTextStream on: (ByteArray new: 5000)).
	file binary.
	(self on: file mapping: aSyReferenceMapping) nextPut: anObject.
	^file contents! !

!SyReferenceMappingStream class methodsFor: 'as yet unclassified' stamp: 'mt 6/15/2010 15:30:34.12'!
unStream: messageBytes mapping: aSyReferenceMapping

	"copied from DataStream class >> #streamedRepresentationOf:"
	^(self
		on: ((RWBinaryOrTextStream with: messageBytes) reset; binary)
		mapping: aSyReferenceMapping) next! !

!SyReferenceMappingStream methodsFor: 'accessing' stamp: 'mt 6/15/2010 15:28:48.149'!
mapping

	^ mapping ifNil: [mapping := SyReferenceMapping new]! !

!SyReferenceMappingStream methodsFor: 'accessing' stamp: 'mt 6/15/2010 14:59:33.612'!
mapping: aSyReferenceMapping

	mapping := aSyReferenceMapping! !

!SyReferenceMappingStream methodsFor: 'write and read' stamp: 'mt 6/15/2010 15:02:47.878'!
next

	| unconverted |
	unconverted := super next.
	^ self mapping backward value: unconverted.! !

!SyReferenceMappingStream methodsFor: 'write and read' stamp: 'mt 6/15/2010 15:02:57.417'!
nextPut: anObject

	| converted |
	converted := self mapping foreward value: anObject.
	^ super nextPut: converted.! !

Exception subclass: #SyApplyCommandRefusedException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

Exception subclass: #SyClientClosedConnectionException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SyClientClosedConnectionException commentStamp: 'SR 6/5/2010 19:16:20.123' prior: 0!
Thrown by execute methods if client connection should be closed.!

!Object methodsFor: '*SqSync' stamp: 'SR 6/18/2010 15:37:57.573'!
allInstanceVariableValues
	"Answer a collection whose elements are the values of those instance variables of the receiver"
	| c |
	c := OrderedCollection new.
	1 to: self class instSize do:
		[:i | c add: (self instVarAt: i)].
	^ c! !

!Object methodsFor: '*SqSync' stamp: 'SR 6/18/2010 14:46:18.381'!
isSqEntityType

	^ false! !

Object subclass: #SqEntity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Repository'!

SqEntity subclass: #Person
	instanceVariableNames: 'givenName surname birthday address friends specialFriend'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!Person commentStamp: 'mt 5/19/2010 13:05:53.083' prior: 0!
I am part of the example domain model.!

!Person class methodsFor: 'as yet unclassified' stamp: 'SR 5/15/2010 12:28:45.274'!
givenName: aFirstString surname: aSecondString

	^ (self new)
		givenName: aFirstString;
		surname: aSecondString;
		yourself.! !

!Person methodsFor: 'comparing' stamp: 'SR 5/15/2010 15:24:16.133'!
= anObject 

	^ (self givenName = anObject givenName) and: [self surname = anObject surname] and: [self birthday = anObject birthday] and: [self address = anObject address]! !

!Person methodsFor: 'accessing' stamp: 'SR 6/14/2010 19:02:41.623'!
addFriend: aPerson

	self friends add: aPerson! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:25:08.009'!
address
	^ address! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:26:51.253'!
address: aString

	(aString isString) ifFalse: [Exception signal: 'Invalid data type'].
	address := aString! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:25:18.253'!
birthday
	^ birthday! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:27:34.621'!
birthday: aString

	(aString isString) ifFalse: [Exception signal: 'Invalid data type'].
	birthday := aString! !

!Person methodsFor: 'accessing' stamp: 'SR 6/14/2010 18:58:53.508'!
friends

	^ friends! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:25:24.381'!
givenName
	^ givenName! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:26:32.385'!
givenName: aString

	(aString isString) ifFalse: [Exception signal: 'Invalid data type'].
	givenName := aString! !

!Person methodsFor: 'initialize-release' stamp: 'SR 6/14/2010 19:46:29.512'!
initialize

	friends := OrderedCollection new.! !

!Person methodsFor: 'accessing' stamp: 'SR 6/14/2010 18:59:22.951'!
specialFriend

	^ specialFriend! !

!Person methodsFor: 'accessing' stamp: 'SR 6/14/2010 18:59:26.151'!
specialFriend: anObject

	specialFriend := anObject! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:25:32.002'!
surname
	^ surname! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:26:22.555'!
surname: aString

	(aString isString) ifFalse: [Exception signal: 'Invalid data type'].
	surname := aString.! !

SqEntity subclass: #PersonList
	instanceVariableNames: 'persons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!PersonList methodsFor: 'accessing' stamp: 'SR 6/14/2010 20:03:42.855'!
addPerson: aPerson

	persons add: aPerson! !

!PersonList methodsFor: 'initialize-release' stamp: 'SR 6/14/2010 20:03:26.872'!
initialize

	super initialize.
	
	persons := OrderedCollection new.! !

!PersonList methodsFor: 'accessing' stamp: 'SR 6/14/2010 20:03:33.95'!
persons

	^ persons! !

!SqEntity methodsFor: 'testing' stamp: 'SR 6/18/2010 14:46:38.385'!
isSqEntityType

	^ true! !

Object subclass: #SyClassInstrumentor
	instanceVariableNames: 'wrappers processor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Repository'!

!SyClassInstrumentor commentStamp: 'SR 5/20/2010 18:32:53.47' prior: 0!
Used to configure method wrappers:

| instr o1 |
instr := SyClassInstrumentor new.
o1 := Person new.

instr instrumentClass: (o1 class).
o1 givenName: 'test'.
instr uninstrumentAllAndReset.

If not correctly clean up, use: SyMethodWrapper allInstances do: [:mw|mw uninstall]!

!SyClassInstrumentor class methodsFor: 'support' stamp: 'rkrk 6/14/2010 01:21:03.701'!
cleanClass: class

	"self cleanClass: Person"
	self new uninstrumentClass: class.! !

!SyClassInstrumentor methodsFor: 'instrumenting' stamp: 'mt 6/12/2010 17:59:40.643'!
instrumentClass: aClass

	{aClass. aClass class} do: [:c |
		c selectors do: [:selector |
			self instrumentMethod: selector inClass: c ]].! !

!SyClassInstrumentor methodsFor: 'instrumenting' stamp: 'mt 6/12/2010 18:01:36.24'!
instrumentMethod: selector inClass: aClass

	(self isMethodInstrumented: selector inClass: aClass) ifFalse: [
		SystemChangeNotifier uniqueInstance doSilently: [
			(self wrappers add:
				(SyMethodWrapper on: selector inClass: aClass for: self))
				install]].! !

!SyClassInstrumentor methodsFor: 'testing' stamp: 'rkrk 6/14/2010 01:02:03.766'!
isMethodInstrumented: selector inClass: aClass

	^ self wrappers anySatisfy: [:wrapper |
		wrapper wrappedClass = aClass and: [wrapper selector = selector]]! !

!SyClassInstrumentor methodsFor: 'instrumenting' stamp: 'rkrk 6/2/2010 21:03:42.277'!
methodCalled: aSelector on: anObject with: args resulting: result

	self processor ifNil: [^self].
	self processor
		process: aSelector
		on: anObject
		with: args.! !

!SyClassInstrumentor methodsFor: 'accessing' stamp: 'SR 5/17/2010 19:48:49.324'!
processor
	^ processor! !

!SyClassInstrumentor methodsFor: 'accessing' stamp: 'SR 5/17/2010 19:48:49.336'!
processor: anObject
	processor := anObject! !

!SyClassInstrumentor methodsFor: 'instrumenting' stamp: 'mt 6/12/2010 18:04:16.121'!
uninstrumentAllAndReset

	self wrappers do: [:wrapper | wrapper uninstall].
	wrappers := nil.! !

!SyClassInstrumentor methodsFor: 'instrumenting' stamp: 'mt 6/12/2010 18:06:26.459'!
uninstrumentClass: aClass

	self wrappers
		select: [:wrapper | wrapper wrappedClass = aClass or: [wrapper wrappedClass = aClass class]]
		thenDo: [:wrapper | wrapper uninstall. self wrappers remove: wrapper ifAbsent: ["Weak."]]! !

!SyClassInstrumentor methodsFor: 'instrumenting' stamp: 'mt 6/12/2010 18:08:28.817'!
uninstrumentMethod: aCompiledMethod

	self wrappers
		select: [:wrapper | wrapper clientMethod = aCompiledMethod]
		thenDo: [:wrapper | wrapper uninstall. self wrappers remove: wrapper ifAbsent: ["weak."]].
! !

!SyClassInstrumentor methodsFor: 'accessing' stamp: 'mt 6/12/2010 17:49:25.948'!
wrappers

	^ wrappers ifNil: [wrappers := WeakSet new]! !

Object subclass: #SyClient
	instanceVariableNames: 'socket repository protocolProcessor connectionProcess incomingCommandProcess pendingApplyCommandQueue pendingApplyCommandQueueWorker shouldDeferSends'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Client'!

!SyClient commentStamp: 'mt 6/13/2010 15:24:45.171' prior: 0!
The client has 4 processes at the moment:

- UI process for interactions from workspace
- connection process to incoming network data
- process to handle incoming commands from protocol processor
- process to send apply-commands blocking!

!SyClient methodsFor: 'accessing' stamp: 'rkrk 6/14/2010 01:44:57.148'!
commandsNotYetSend

	^ pendingApplyCommandQueue! !

!SyClient methodsFor: 'connection-handling' stamp: 'SR 6/5/2010 19:42:24.879'!
connectToHostNamed: aHost port: aPort

	socket := SyTcpSocket openConnectionToHostNamed: aHost port: aPort.
	self
		startConnectionThread;
		pvtUpdateRepository;
		startIncomingCommandProcess.! !

!SyClient methodsFor: 'debugging' stamp: 'rkrk 6/14/2010 00:28:30.287'!
deferSends

	shouldDeferSends := true.
	self killPendingApplyCommandQueueWorker.! !

!SyClient methodsFor: 'connection-handling' stamp: 'mt 6/13/2010 15:35:02.365'!
disconnect

	"Kill command processing"
	incomingCommandProcess ifNotNilDo: [:proc | proc terminate].

	socket ifNil: [^ self].
	
	"Kill connection"
	connectionProcess terminate.
	protocolProcessor killOutgoingQueueWorker.
	self killPendingApplyCommandQueueWorker.
	socket close.
	
	"Clear method wrapper"
	repository clear.! !

!SyClient methodsFor: 'debugging' stamp: 'rkrk 6/14/2010 00:28:56.379'!
dontDeferSends

	shouldDeferSends := false.
	self pvtCheckPendingApplyCommandQueueWorker.! !

!SyClient methodsFor: 'initialize-release' stamp: 'mt 6/15/2010 15:46:39.989'!
initialize

	super initialize.
	
	repository := SyRepository new
		shouldCreateApplyCommands: true;
		addDependent: self; "for sending commands"
		yourself.
	protocolProcessor := SySimpleProtocolProcessor new
		objectMapping: (SyReferenceMapping foreward: repository forewardReferenceMappingBlock backward: repository backwardReferenceMappingBlock).
	pendingApplyCommandQueue := SharedQueue new.
	shouldDeferSends := false.! !

!SyClient methodsFor: 'connection-handling' stamp: 'SR 5/15/2010 14:50:21.163'!
isConnected

	socket ifNil: [ ^ false ].
	^ socket isConnected! !

!SyClient methodsFor: 'command handling' stamp: 'rkrk 6/13/2010 23:38:46.905'!
killPendingApplyCommandQueueWorker

	pendingApplyCommandQueueWorker isNilOrTerminated
		ifFalse: [pendingApplyCommandQueueWorker terminate].! !

!SyClient methodsFor: 'debugging' stamp: 'rkrk 6/2/2010 17:15:54.023'!
log: msg

	Transcript cr; show: msg asString.! !

!SyClient methodsFor: 'accessing' stamp: 'rkrk 6/14/2010 17:08:09.674'!
mapRegisteredObjectsBlock

	^ [:o | o].! !

!SyClient methodsFor: 'command handling' stamp: 'rkrk 6/13/2010 23:35:06.971'!
processIncomingCommands
	"See SySimpleProtocolProcessor>>pvtProcessCommand:senderID: for more infos."
	
	| array command senderStream |
	array := protocolProcessor nextCommand.

	command := array second.
	senderStream := array third.
	
	self log: 'SyClient (' , self identityHash asString , ') processing: ' , command asString.
	
	[command execute: self repository] "Just execute the command. No response expected yet."
		on: SyClientClosedConnectionException
		do: [senderStream close]
		on: SyApplyCommandRefusedException
		do: [Transcript cr; show: 'SyApplyCommand refused for client (', self identityHash asString, ')!!'. self reboot].! !

!SyClient methodsFor: 'command handling' stamp: 'SR 6/14/2010 19:34:23.866'!
pvtCheckPendingApplyCommandQueueWorker

	"Send all apply-commands blocking to verify their execution."
	pendingApplyCommandQueueWorker isNilOrTerminated ifFalse: [^self].
	pendingApplyCommandQueueWorker := [ | command result |
		[(command := pendingApplyCommandQueue nextOrNil) notNil] whileTrue: [
			self log: 'Client (' , self identityHash asString , ') sending: ' , command asString.
			result := protocolProcessor
				sendCommandBlocking: command
				on: socket.
			"Schedule a local command to be processed by the one and only process that accesses the repository."
			protocolProcessor nextCommandPutLocal:
				(SyResultProxyCommand forCommand: result)]] sqFork.! !

!SyClient methodsFor: 'orchestration' stamp: 'SR 6/14/2010 19:34:32.825'!
pvtUpdateRepository

	| command |
	command := protocolProcessor
		sendCommandBlocking: SyListCommand new
		on: socket.
	command executeWithResult: self repository.! !

!SyClient methodsFor: 'initialize-release' stamp: 'mt 6/13/2010 16:32:01.015'!
reboot

	| newClient host port |
	host := socket remoteAddress.
	port := socket remotePort.
	
	self disconnect.
	
	newClient := self class new.
	newClient connectToHostNamed: host port: port.
	
	self becomeForward: newClient.
	! !

!SyClient methodsFor: 'initialize-release' stamp: 'rkrk 6/13/2010 23:39:49.115'!
release

	self isConnected ifTrue: [self disconnect].
	^ super release! !

!SyClient methodsFor: 'accessing' stamp: 'SR 6/1/2010 10:26:06.706'!
repository

	^ repository! !

!SyClient methodsFor: 'connection-handling' stamp: 'SR 6/7/2010 10:02:38.587'!
startConnectionThread

	connectionProcess := [
		[socket isConnected] whileTrue: [
			socket waitForDataIfClosed: [self disconnect].
			(protocolProcessor processDataFrom: socket)
				ifFalse: [self disconnect]]] sqFork.! !

!SyClient methodsFor: 'command handling' stamp: 'SR 6/7/2010 09:59:54.799'!
startIncomingCommandProcess
	"This process triggers the continous work of the server."
	
	incomingCommandProcess := [
		[self processIncomingCommands] repeat.
	] sqFork.! !

!SyClient methodsFor: 'orchestration' stamp: 'rkrk 6/14/2010 00:28:20.513'!
update: anAspect with: command

	(anAspect = #operation) ifFalse: [super update: anAspect with: command].

	pendingApplyCommandQueue nextPut: command.
	shouldDeferSends ifFalse: [
		self pvtCheckPendingApplyCommandQueueWorker].! !

Object subclass: #SyCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

SyCommand subclass: #SyApplyCommand
	instanceVariableNames: 'selector receiverUUIDString expectedVersion wasExecuted arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SyApplyCommand class methodsFor: 'instance creation' stamp: 'mt 6/15/2010 15:24:22.489'!
receiver: aRegisteredObject selector: aSelector arguments: anArray

	^ self new
		receiverUUIDString: aRegisteredObject uuid asString;
		selector: aSelector;
		arguments: anArray;
		expectedVersion: aRegisteredObject version;
		yourself.! !

!SyApplyCommand class methodsFor: 'execution' stamp: 'mt 6/15/2010 15:18:35.161'!
shouldBeReplicated

	^ true! !

!SyApplyCommand methodsFor: 'testing' stamp: 'SR 6/1/2010 09:57:39.714'!
= other

	^ self receiverUUID = other receiverUUID
		and: [self selector = other selector]
		and: [self arguments = other arguments]! !

!SyApplyCommand methodsFor: 'accessing' stamp: 'mt 6/15/2010 15:22:01.583'!
arguments
	
	^ arguments! !

!SyApplyCommand methodsFor: 'accessing' stamp: 'SR 6/1/2010 10:21:04.672'!
arguments: anObject

	arguments := anObject! !

!SyApplyCommand methodsFor: 'execution' stamp: 'mt 6/15/2010 16:01:41.295'!
execute: aSyRepository

	| recv regRecv |
	recv := aSyRepository resolve: self receiverUUID.
	recv ifNil: [ ^ false	"SyNotFoundException signal" ].	"Check version."
	regRecv := aSyRepository registeredObjectForUUID: self receiverUUID.
	
	Transcript
		cr; show: 'Checking versions: ';
		show: regRecv version asString; space;
		show: self expectedVersion asString.
	
	regRecv version = self expectedVersion
		ifFalse: [ ^ false	"SyObjectVersionMismatchException signal" ].
	
	aSyRepository dontCreateApplyCommandsDuring: [
		recv
			perform: self selector asSymbol
			withArguments: self arguments].
		
	"Execution done. Now add to operation stack. Increase Version."
	regRecv operations add: self.
	self wasExecuted: true.
	^ true! !

!SyApplyCommand methodsFor: 'execution' stamp: 'mt 6/15/2010 16:01:41.218'!
executeWithResult: aRepository
	"If this command is sent blocking to the server, then this message should be called on the return value to see if the apply-command was accepted."

	self wasExecuted
		ifTrue: [
			"Increase version."
			(aRepository registeredObjectForUUID: self receiverUUID) operations add: self]
		ifFalse: [SyApplyCommandRefusedException signal].! !

!SyApplyCommand methodsFor: 'accessing' stamp: 'mt 6/12/2010 14:20:16.92'!
expectedVersion
	"Specifies the expected version number that has to be verified before performing the method call on the receiver."

	^ expectedVersion! !

!SyApplyCommand methodsFor: 'accessing' stamp: 'mt 6/12/2010 14:20:35.269'!
expectedVersion: anInteger

	expectedVersion := anInteger.! !

!SyApplyCommand methodsFor: 'printing' stamp: 'SR 6/14/2010 22:59:30.901'!
printOn: aStream

	super printOn: aStream.
	aStream
		nextPut: $(;
		print: self receiverUUID;
		nextPutAll: '>>#';
		nextPutAll: self selector;
		nextPut: $).! !

!SyApplyCommand methodsFor: 'accessing' stamp: 'rkrk 6/2/2010 21:51:19.365'!
receiverUUID

	^ UUID fromString: self receiverUUIDString! !

!SyApplyCommand methodsFor: 'accessing' stamp: 'SR 6/5/2010 19:20:05.904'!
receiverUUIDString

	^ receiverUUIDString! !

!SyApplyCommand methodsFor: 'accessing' stamp: 'SR 6/5/2010 19:20:09.051'!
receiverUUIDString: anObject

	receiverUUIDString := anObject! !

!SyApplyCommand methodsFor: 'accessing' stamp: 'SR 6/1/2010 10:20:57.086'!
selector

	^ selector! !

!SyApplyCommand methodsFor: 'accessing' stamp: 'SR 6/1/2010 10:20:53.995'!
selector: anObject

	selector := anObject! !

!SyApplyCommand methodsFor: 'accessing' stamp: 'mt 6/13/2010 10:13:53.676'!
wasExecuted

	^ wasExecuted ifNil: [wasExecuted := false]! !

!SyApplyCommand methodsFor: 'accessing' stamp: 'mt 6/12/2010 19:09:57.172'!
wasExecuted: aBoolean

	wasExecuted := aBoolean.! !

!SyCommand class methodsFor: 'testing' stamp: 'mt 6/15/2010 15:17:01.606'!
needsObjectMapping
	"Returns whether this command should be serialised using the repository object mapping."
	^ true! !

!SyCommand class methodsFor: 'testing' stamp: 'mt 6/15/2010 15:17:20.567'!
shouldBeReplicated
	"Returns whether this command should be replicated to all other clients"

	^ false! !

!SyCommand methodsFor: 'comparing' stamp: 'SR 6/1/2010 14:42:27.575'!
= anObject

	(self className = anObject className) ifFalse: [^ false].
	(self class instSize = anObject class instSize) ifFalse: [^ false].
	self instanceVariableValues withIndexDo: [ :value :index | ((anObject instVarAt: index) = value) ifFalse: [^ false]].
	
	^ true
	! !

!SyCommand methodsFor: 'execution' stamp: 'SR 6/1/2010 10:48:12.618'!
execute: aSyRepository
	"Should implement the functionality of this command. For now only the repository is supplied. Should return false if connection should be closed. Otherwise true."
	
	self subclassResponsibility! !

!SyCommand methodsFor: 'execution' stamp: 'SR 6/5/2010 19:18:58.009'!
executeWithResult: aSyRepository
	"If the command has a special meaning when it is executed on the sender side after being executed on the receiver side, this should be overridden. Parameter and results are the same as with #execute:"! !

SyCommand subclass: #SyListCommand
	instanceVariableNames: 'objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SyListCommand commentStamp: 'SR 6/1/2010 14:12:13.781' prior: 0!
Example command: {"type": "command", "command": {"instVars": [null], "class": "SyListCommand"}, "id": 0}!

!SyListCommand class methodsFor: 'testing' stamp: 'mt 6/15/2010 15:17:39.026'!
needsObjectMapping

	^ false! !

!SyListCommand methodsFor: 'execution' stamp: 'rkrk 6/13/2010 23:29:06.514'!
execute: aSyRepository

	objects := aSyRepository metaRepository collect: [:regObject |
		self pvtCreateRegObjectDictionary: regObject].
	^ true! !

!SyListCommand methodsFor: 'execution' stamp: 'SR 6/14/2010 19:44:41.346'!
executeWithResult: aSyRepository

	objects do: [:data |
		aSyRepository
			register: (data at: #client)
			uuid: (UUID fromString: (data at: #uuidString))
			version: (data at: #version)].
	^ true! !

!SyListCommand methodsFor: 'accessing' stamp: 'SR 6/1/2010 10:45:57.765'!
objects

	^ objects! !

!SyListCommand methodsFor: 'accessing' stamp: 'SR 6/1/2010 10:46:00.502'!
objects: anObject

	objects := anObject! !

!SyListCommand methodsFor: 'execution' stamp: 'SR 6/14/2010 19:49:53.155'!
pvtCreateRegObjectDictionary: aRegisteredObject

	^ Dictionary newFrom: {
		#uuidString -> aRegisteredObject uuidString.
		#version -> aRegisteredObject version.
		#client -> aRegisteredObject client.}! !

SyCommand subclass: #SyQuitCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SyQuitCommand commentStamp: 'SR 6/1/2010 14:12:24.447' prior: 0!
Example command: {"type": "command", "command": {"instVars": [], "class": "SyQuitCommand"}, "id": 1}!

!SyQuitCommand methodsFor: 'execution' stamp: 'SR 6/5/2010 19:18:16.985'!
execute: aSyRepository

	SyClientClosedConnectionException signal! !

SyCommand subclass: #SyRegisterCommand
	instanceVariableNames: 'clientClassName clientInstanceVariables uuid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SyRegisterCommand class methodsFor: 'instance creation' stamp: 'SR 6/18/2010 15:40:15.05'!
domainObject: aDomainObject

	^ self new
		clientClassName: aDomainObject className;
		clientInstanceVariables: aDomainObject allInstanceVariableValues! !

!SyRegisterCommand class methodsFor: 'testing' stamp: 'SR 6/18/2010 15:33:24.715'!
shouldBeReplicated
	"Returns whether this command should be replicated to all other clients"

	^ true! !

!SyRegisterCommand methodsFor: 'accessing' stamp: 'SR 6/18/2010 15:39:33.373'!
clientClassName
	^ clientClassName! !

!SyRegisterCommand methodsFor: 'accessing' stamp: 'SR 6/18/2010 15:39:33.386'!
clientClassName: anObject
	clientClassName := anObject! !

!SyRegisterCommand methodsFor: 'accessing' stamp: 'SR 6/18/2010 15:39:33.396'!
clientInstanceVariables
	^ clientInstanceVariables! !

!SyRegisterCommand methodsFor: 'accessing' stamp: 'SR 6/18/2010 15:39:33.407'!
clientInstanceVariables: anObject
	clientInstanceVariables := anObject! !

!SyRegisterCommand methodsFor: 'execution' stamp: 'SR 6/18/2010 15:46:25.903'!
execute: aSyRepository

	| object |
	object := (Smalltalk classNamed: self clientClassName) new.
	self clientInstanceVariables withIndexDo: [:val :idx | object instVarAt: idx put: val].
	
	self uuid
		ifNil: [self uuid: (aSyRepository register: object) uuid]
		ifNotNil: [aSyRepository register: object uuid: self uuid].
		
	^ true
	.
	! !

!SyRegisterCommand methodsFor: 'execution' stamp: 'SR 6/18/2010 15:46:30.554'!
executeWithResult: aSyRepository

	^ true! !

!SyRegisterCommand methodsFor: 'accessing' stamp: 'SR 6/18/2010 15:39:11.087'!
uuid
	^ uuid! !

!SyRegisterCommand methodsFor: 'accessing' stamp: 'SR 6/18/2010 15:39:11.098'!
uuid: anObject
	uuid := anObject! !

SyCommand subclass: #SyResultProxyCommand
	instanceVariableNames: 'command'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SyResultProxyCommand commentStamp: 'mt 6/13/2010 15:30:21.46' prior: 0!
Use this command to redirect #executeWithResult: to #execute: for any given command.!

!SyResultProxyCommand class methodsFor: 'instance creation' stamp: 'mt 6/13/2010 15:30:51.035'!
forCommand: aCommand

	^ self new
		command: aCommand! !

!SyResultProxyCommand methodsFor: 'accessing' stamp: 'mt 6/13/2010 15:31:06'!
command

	^ command! !

!SyResultProxyCommand methodsFor: 'accessing' stamp: 'mt 6/13/2010 15:31:13.062'!
command: aCommand

	command := aCommand.! !

!SyResultProxyCommand methodsFor: 'execution' stamp: 'mt 6/13/2010 15:31:36.929'!
execute: aRepository

	^ self command executeWithResult: aRepository! !

Object subclass: #SyProtocolProcessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SyProtocolProcessor methodsFor: 'receiving' stamp: 'mt 6/12/2010 19:50:29.738'!
processDataFrom: aStream

	self subclassResponsibility.! !

!SyProtocolProcessor methodsFor: 'sending' stamp: 'SR 5/20/2010 18:27:17.111'!
sendCommandBlocking: aCommandString on: aStream
	"Sends command to server and returns its answer. Responsible for command-response-scheme."
	
	self subclassResponsibility! !

!SyProtocolProcessor methodsFor: 'sending' stamp: 'SR 6/1/2010 11:46:29.438'!
sendCommandNonBlocking: anOperation on: aStream
	"Sends a command to the server, but does so asynchronously. Therefore all implementions should return fast."

	self subclassResponsibility! !

!SyProtocolProcessor methodsFor: 'sending' stamp: 'SR 6/5/2010 19:50:05.89'!
sendCommandNonBlocking: aSyCommand onAll: someStreams
	"Sends a command to some servers/clients, but does so asynchronously. Therefore all implementions should return fast."

	self subclassResponsibility! !

!SyProtocolProcessor methodsFor: 'sending' stamp: 'SR 6/1/2010 11:47:04.728'!
sendCommandResult: aCommand with: aCommandId on: aStream
	"Sends a command back after it has been processed, does so asynchronously. Therefore all implementions should return fast."

	self subclassResponsibility! !

SyProtocolProcessor subclass: #SySimpleProtocolProcessor
	instanceVariableNames: 'outgoingQueue outgoingQueueWorker incomingQueue currentCommandResultCache currentCommandResultSemaphore currentCommandResultId nextCommandID objectMapping'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SySimpleProtocolProcessor commentStamp: 'mt 5/31/2010 09:15:17.382' prior: 0!
Wire Protocol
---

1) All data is serialized or deserialized according to #serialize: and #deserialize:.

2) In a first version, JSON is used to serialize messages.

3) Messages are separated on the wire using a unique #messageEndToken.

4) Each message is dictionary with the following content:
	#channel -> aNumber
	#data -> aString
	
5) There is a #channel for commands, one for results of commands, and one for operations/updates.

6) For each command an increasing ID is sent along to verify the result on the command result channel:
	#id -> aNumber
	#command -> aString
	
7) The result of a command is as follows:
	#id -> aNumber
	#result -> aString
	
8) Update messages have to be deserialized in the #data field.!

!SySimpleProtocolProcessor class methodsFor: 'constants' stamp: 'SR 6/1/2010 12:24:19.963'!
messageEndToken
	"Return the token that will be transferred after the end of each message to allow the recipient of the message to recognize it fully. No message should contain this token."
	
	^ String crlf! !

!SySimpleProtocolProcessor methodsFor: 'serialisation' stamp: 'mt 6/15/2010 15:09:48.087'!
deserialize: aByteString withMapping: aBoolean

	^ SyReferenceMappingStream
		unStream: (ByteArray readFrom: aByteString)
		mapping: (aBoolean ifTrue: [self objectMapping] ifFalse: [])! !

!SySimpleProtocolProcessor methodsFor: 'initialize-release' stamp: 'mt 6/15/2010 15:37:39.45'!
initialize

	super initialize.
	outgoingQueue := SharedQueue new. "To send outgoing commands."
	incomingQueue := SharedQueue new. "To schedule incoming commands."
	
	currentCommandResultSemaphore := Semaphore new. "To wait for command results."
	nextCommandID := 0.
	
	objectMapping := SyReferenceMapping identity.! !

!SySimpleProtocolProcessor methodsFor: 'sending' stamp: 'rkrk 6/13/2010 23:40:11.99'!
killOutgoingQueueWorker
	"Only use in client mode."

	outgoingQueueWorker isNilOrTerminated
		ifFalse: [outgoingQueueWorker terminate].! !

!SySimpleProtocolProcessor methodsFor: 'accessing' stamp: 'SR 6/1/2010 13:59:39.663'!
nextCommand
	"Retrieve the next pending command from the incoming command queue."
	
	^ incomingQueue next! !

!SySimpleProtocolProcessor methodsFor: 'accessing' stamp: 'mt 6/13/2010 15:28:26.257'!
nextCommandPutLocal: aCommand
	"Schedule a command that was obiously created locally and has to be processed locally too. Intent: Reusage of incomingQueue for process synchronization."
	
	incomingQueue nextPut: {
		-1. "Local command."
		aCommand.
		nil}.! !

!SySimpleProtocolProcessor methodsFor: 'accessing' stamp: 'mt 5/30/2010 21:45:15.615'!
nextUpdate
	"Retrieve the next pending operation from the incoming update queue."
	
	^ incomingQueue next! !

!SySimpleProtocolProcessor methodsFor: 'accessing' stamp: 'SR 6/14/2010 19:32:09.217'!
objectMapping

	^ objectMapping! !

!SySimpleProtocolProcessor methodsFor: 'accessing' stamp: 'SR 6/14/2010 19:32:12.091'!
objectMapping: anObject

	objectMapping := anObject! !

!SySimpleProtocolProcessor methodsFor: 'receiving' stamp: 'mt 6/15/2010 15:20:57.869'!
processDataFrom: aStream
	"Depending on the channel, process the data"
	
	| message command rawMessage commandClass |
	rawMessage := aStream upToAll: SySimpleProtocolProcessor messageEndToken.
	rawMessage isEmpty ifTrue: [^ false].
	
	message := self deserialize: rawMessage withMapping: false.
	commandClass := Smalltalk classNamed: (message at: #commandClass).
	command := self deserialize: (message at: #command) withMapping: commandClass needsObjectMapping.

	((message at: #type) = 'command') ifTrue: [
		^ self
			pvtProcessCommand: command
			with: (message at: #id)
			from: aStream].
			
	((message at: #type) = 'result') ifTrue: [
		^ self
			pvtProcessCommandResult: command
			with: (message at: #id)
			from: aStream].
			
! !

!SySimpleProtocolProcessor methodsFor: 'sending' stamp: 'SR 6/14/2010 19:33:43.392'!
pvtCheckOutgoingQueueWorker
	"Only use in client mode."

	outgoingQueueWorker isNilOrTerminated ifTrue: [
		outgoingQueueWorker := [ | opArray operationDict |
			opArray := outgoingQueue nextOrNil.
			[opArray isNil] whileFalse: [
				self
					pvtSendCommand: opArray second
					with: opArray first
					on: opArray third.
				opArray := outgoingQueue nextOrNil]] sqFork].! !

!SySimpleProtocolProcessor methodsFor: 'serialisation' stamp: 'rkrk 6/15/2010 00:40:01.712'!
pvtCreateCommand: aDictionary

	| typeName variableData newObject |
	typeName := aDictionary at: #class.
	variableData := aDictionary at: #instVars.
	
	newObject := (Smalltalk classNamed: typeName asSymbol) new.
	variableData withIndexDo: [:value :index | newObject instVarAt: index put: value].
	
	^ newObject! !

!SySimpleProtocolProcessor methodsFor: 'sending' stamp: 'SR 6/1/2010 11:54:22.057'!
pvtNextCommandId

	| result |
	result := nextCommandID.
	nextCommandID := nextCommandID + 1.
	^ result! !

!SySimpleProtocolProcessor methodsFor: 'receiving' stamp: 'SR 6/1/2010 13:51:25.804'!
pvtProcessCommand: aCommand with: aCommandId from: aStream
	"Support commands."
	
	"Schedule incoming command to be processed by client or server application."
	incomingQueue nextPut: {
		aCommandId.
		aCommand.
		aStream}.
		
	^ true! !

!SySimpleProtocolProcessor methodsFor: 'receiving' stamp: 'SR 6/1/2010 13:51:33.336'!
pvtProcessCommandResult: aCommand with: aCommandId from: aStream
	"Save the command result and signal."
	
	currentCommandResultId := aCommandId.
	currentCommandResultCache := aCommand.
	currentCommandResultSemaphore signal.

	"Never close connection"
	^ true! !

!SySimpleProtocolProcessor methodsFor: 'sending' stamp: 'mt 6/15/2010 15:26:43.641'!
pvtSendCommand: aCommand with: aCommandId on: aStream

	| data dict |
	dict := Dictionary newFrom: {
		#id -> aCommandId.
		#type -> 'command'.
		#commandClass -> aCommand className.
		#command -> (self serialize: aCommand withMapping: aCommand class needsObjectMapping).}.
	data := self serialize: dict withMapping: false.
	
	aStream nextPutAll: data , SySimpleProtocolProcessor messageEndToken.! !

!SySimpleProtocolProcessor methodsFor: 'sending' stamp: 'SR 6/14/2010 19:33:58.437'!
sendCommandBlocking: command on: stream
	"Sends a command and returns its answer. Responsible for command-response-scheme."

	| commandId |
	commandId := self
		sendCommandNonBlocking: command
		on: stream.
	[currentCommandResultId = commandId] whileFalse: [ 
		currentCommandResultSemaphore wait].
	^ currentCommandResultCache.! !

!SySimpleProtocolProcessor methodsFor: 'sending' stamp: 'SR 6/14/2010 19:35:19.306'!
sendCommandNonBlocking: aSyCommand on: aStream

	| commandId |
	commandId := self pvtNextCommandId.
	outgoingQueue nextPut: {commandId. aSyCommand. aStream.}.
	self pvtCheckOutgoingQueueWorker.
	
	^ commandId! !

!SySimpleProtocolProcessor methodsFor: 'sending' stamp: 'SR 6/14/2010 19:35:44.447'!
sendCommandNonBlocking: aSyCommand onAll: someStreams

	^ someStreams collect: [:aStream | 
		self
			sendCommandNonBlocking: aSyCommand
			on: aStream].! !

!SySimpleProtocolProcessor methodsFor: 'sending' stamp: 'mt 6/15/2010 15:39:04.504'!
sendCommandResult: aCommand with: aCommandId on: aStream
	"Sends command result repeating the given ID so that the sender of the command can map the result correctly."

	| data dict |
	dict := Dictionary newFrom: {
		#id -> aCommandId.
		#type -> 'result'.
		#commandClass -> aCommand className.
		#command -> (self serialize: aCommand withMapping: aCommand class needsObjectMapping).}.
	data := self serialize: dict withMapping: true.
	
	aStream nextPutAll: data , SySimpleProtocolProcessor messageEndToken.! !

!SySimpleProtocolProcessor methodsFor: 'serialisation' stamp: 'mt 6/15/2010 15:07:46.568'!
serialize: anObject withMapping: aBoolean

	^ (SyReferenceMappingStream
		streamedRepresentationOf: anObject
		mapping: (aBoolean ifTrue: [self objectMapping] ifFalse: [])) storeString! !

Object subclass: #SyReference
	instanceVariableNames: 'uuid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Repository'!

!SyReference class methodsFor: 'instance creation' stamp: 'mt 6/15/2010 16:11:30.775'!
fromRegisteredObject: aSyRegisteredObject

	^ self new uuid: aSyRegisteredObject uuid! !

!SyReference methodsFor: 'accessing' stamp: 'mt 6/15/2010 16:10:51.52'!
uuid

	^ uuid! !

!SyReference methodsFor: 'accessing' stamp: 'mt 6/15/2010 16:11:00.598'!
uuid: aUUID

	uuid := aUUID! !

Object subclass: #SyReferenceMapping
	instanceVariableNames: 'foreward backward'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tools'!

!SyReferenceMapping commentStamp: 'mt 6/15/2010 14:58:21.783' prior: 0!
The mappings are blocks exepecting one argument (the object to be mapped)!

!SyReferenceMapping class methodsFor: 'instance creation' stamp: 'mt 6/15/2010 15:34:11.102'!
backward: aBackwardMappingBlock

	^ self new backward: aBackwardMappingBlock! !

!SyReferenceMapping class methodsFor: 'instance creation' stamp: 'mt 6/15/2010 15:34:01.166'!
foreward: aForwardMappingBlock

	^ self new foreward: aForwardMappingBlock! !

!SyReferenceMapping class methodsFor: 'instance creation' stamp: 'mt 6/15/2010 15:32:40.963'!
foreward: aForwardMappingBlock backward: aBackwardMappingBlock

	^ self new
		foreward: aForwardMappingBlock;
		backward: aBackwardMappingBlock! !

!SyReferenceMapping class methodsFor: 'instance creation' stamp: 'mt 6/15/2010 15:35:38.664'!
identity

	^ self new! !

!SyReferenceMapping methodsFor: 'accessing' stamp: 'mt 6/15/2010 15:10:39.715'!
backward

	^ backward ifNil: [ backward := [:o | o]]! !

!SyReferenceMapping methodsFor: 'accessing' stamp: 'mt 6/15/2010 15:02:24.813'!
backward: anObject

	backward := anObject! !

!SyReferenceMapping methodsFor: 'accessing' stamp: 'mt 6/15/2010 15:10:50.078'!
foreward

	^ foreward ifNil: [ foreward := [:o | o]]! !

!SyReferenceMapping methodsFor: 'accessing' stamp: 'mt 6/15/2010 15:02:14.592'!
foreward: anObject

	foreward := anObject! !

Object subclass: #SyRegisteredObject
	instanceVariableNames: 'uuid client operations versionOffset isRoot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Repository'!

!SyRegisteredObject commentStamp: 'mt 6/15/2010 15:59:45.823' prior: 0!
Rename me?!

!SyRegisteredObject class methodsFor: 'instance creation' stamp: 'SR 6/14/2010 18:40:25.654'!
client: anObject uuid: aUUID versionOffset: aVersionNumber asRoot: aBoolean

	^ self new
		client: anObject;
		uuid: aUUID;
		versionOffset: aVersionNumber;
		isRoot: aBoolean;
		yourself.! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'SR 6/1/2010 10:04:53.286'!
client

	^ client! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'SR 6/1/2010 10:04:49.519'!
client: anObject

	client := anObject! !

!SyRegisteredObject methodsFor: 'initialize-release' stamp: 'SR 5/17/2010 20:02:07.393'!
initialize

	super initialize.
	operations := OrderedCollection new.! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'SR 6/14/2010 18:40:17.638'!
isRoot

	^ isRoot! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'SR 6/14/2010 18:40:13.583'!
isRoot: aBoolean

	isRoot := aBoolean! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'mt 6/6/2010 14:35:45.967'!
operations

	^ operations! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'mt 6/6/2010 14:35:49.859'!
operations: anObject

	operations := anObject! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'SR 6/1/2010 10:04:43.328'!
uuid

	^ uuid! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'SR 6/1/2010 10:04:46.39'!
uuid: anObject

	uuid := anObject! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'rkrk 6/2/2010 11:54:26.291'!
uuidString

	^ self uuid asString! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'mt 6/12/2010 15:16:25.975'!
version
	"Return an integer that represents the version of this object with:
	o1 isNewer o2 --> o1 version > o2 version"
	
	^ self operations size + self versionOffset! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'mt 6/12/2010 15:16:39.679'!
versionOffset
	"If only the latest operations are available in the stack, this offset can be used to calculate the real version."
	
	^ versionOffset ifNil: [versionOffset := 0]! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'mt 6/12/2010 15:16:16.786'!
versionOffset: anInteger
	
	versionOffset := anInteger.! !

Object subclass: #SyRepository
	instanceVariableNames: 'objects instrumentor shouldCreateApplyCommands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Repository'!

!SyRepository methodsFor: 'repository' stamp: 'rkrk 6/2/2010 12:58:43.044'!
all

	^ objects collect: [:regObject | regObject client]! !

!SyRepository methodsFor: 'reference mapping' stamp: 'SR 6/18/2010 15:58:42.456'!
backwardReferenceMappingBlock

	^  [:obj | 
		obj class == SyReference
			ifTrue: [(self registeredObjectForReference: obj) ifNotNilDo: [:obj2| obj2 client]]
			ifFalse: [obj]]! !

!SyRepository methodsFor: 'repository' stamp: 'SR 6/1/2010 10:28:01.527'!
clear

	objects := OrderedCollection new.
	instrumentor uninstrumentAllAndReset.! !

!SyRepository methodsFor: 'repository' stamp: 'rkrk 6/13/2010 23:19:20.36'!
dontCreateApplyCommandsDuring: block

	| tmp |
	tmp := self shouldCreateApplyCommands.
	self shouldCreateApplyCommands: false.
	block value.
	self shouldCreateApplyCommands: tmp.! !

!SyRepository methodsFor: 'reference mapping' stamp: 'mt 6/15/2010 16:02:40.003'!
forewardReferenceMappingBlock

	^ [:obj | |regObject|
		regObject := self registeredObjectForDomainObject: obj.
		regObject
			ifNil: [obj]
			ifNotNil: [SyReference fromRegisteredObject: regObject]].! !

!SyRepository methodsFor: 'initialize-release' stamp: 'SR 6/1/2010 09:49:23.889'!
initialize

	super initialize.

	objects := OrderedCollection new.
	instrumentor := SyClassInstrumentor new processor: self.
	
	shouldCreateApplyCommands := false.! !

!SyRepository methodsFor: 'repository' stamp: 'SR 6/1/2010 09:41:38.775'!
isEmpty

	^ objects isEmpty! !

!SyRepository methodsFor: 'repository' stamp: 'SR 6/1/2010 09:30:15.455'!
metaRepository

	^ objects! !

!SyRepository methodsFor: 'method wrappers' stamp: 'SR 6/18/2010 15:48:26.364'!
process: selector on: obj with: args

	| registeredObject applyCommand |
	"Recursion exit condition. Allows multiple clients/servers per Image in combination with multiple SyMethodWrappers."
	registeredObject := (self registeredObjectForDomainObject: obj) ifNil: [^ self].
	
	self pvtCheckArguments: args.
	
	applyCommand := SyApplyCommand
		receiver: registeredObject
		selector: selector
		arguments: args.
		
	self changed: #operation with: applyCommand! !

!SyRepository methodsFor: 'method wrappers' stamp: 'SR 6/18/2010 15:55:16.467'!
pvtCheckArguments: args.
	
	args do: [:obj |
		obj isSqEntityType ifTrue: [
			(self registeredObjectForDomainObject: obj) ifNil: [
				self register: obj]]].! !

!SyRepository methodsFor: 'repository' stamp: 'mt 6/12/2010 15:18:43.373'!
register: anObject

	^ self register: anObject uuid: UUID new! !

!SyRepository methodsFor: 'repository' stamp: 'mt 6/12/2010 15:22:32.958'!
register: anObject uuid: aUUID

	^ self
		register: anObject
		uuid: aUUID
		version: 0 "New object."! !

!SyRepository methodsFor: 'repository' stamp: 'SR 6/14/2010 18:38:17.287'!
register: anObject uuid: aUUID version: aVersionNumber

	^ self register: anObject uuid: aUUID version: aVersionNumber asRoot: false! !

!SyRepository methodsFor: 'repository' stamp: 'SR 6/14/2010 18:38:50.243'!
register: anObject uuid: aUUID version: aVersionNumber asRoot: aBoolean

	| registeredObject |
	(self all identityIncludes: anObject) ifTrue: [
		Exception signal: 'Object already registered'].
	
	registeredObject := SyRegisteredObject
		client: anObject
		uuid: aUUID
		versionOffset: aVersionNumber
		asRoot: aBoolean.
	objects add: registeredObject.
	
	"Wrap objects class if not yet wrapped"
	self shouldCreateApplyCommands ifTrue: [ 
		instrumentor instrumentClass: anObject class].
	
	^ registeredObject.! !

!SyRepository methodsFor: 'repository' stamp: 'mt 6/15/2010 16:00:38.81'!
registeredObjectForDomainObject: aDomainObject

	^ objects
		detect: [:regObj | regObj client == aDomainObject]
		ifNone: []! !

!SyRepository methodsFor: 'repository' stamp: 'mt 6/15/2010 16:01:41.036'!
registeredObjectForReference: aSyReference

	^ self registeredObjectForUUID: aSyReference uuid! !

!SyRepository methodsFor: 'repository' stamp: 'mt 6/15/2010 16:01:40.784'!
registeredObjectForUUID: aUUID

	^ objects
		detect: [:regObj | regObj uuid = aUUID]
		ifNone: [].! !

!SyRepository methodsFor: 'repository' stamp: 'mt 6/15/2010 16:01:40.879'!
resolve: aUUID

	^ (self registeredObjectForUUID: aUUID) ifNotNilDo: [ :ro| ro client]
! !

!SyRepository methodsFor: 'repository' stamp: 'SR 6/14/2010 18:44:57.93'!
rootObject

	^ (objects detect: [:o | o isRoot ] ifNone: [^ nil]) client! !

!SyRepository methodsFor: 'repository' stamp: 'SR 6/14/2010 18:41:52.466'!
rootObject: anObject

	^ self register: anObject uuid: UUID new version: 0 asRoot: true! !

!SyRepository methodsFor: 'accessing' stamp: 'SR 6/1/2010 09:32:26.583'!
shouldCreateApplyCommands

	^ shouldCreateApplyCommands! !

!SyRepository methodsFor: 'accessing' stamp: 'mt 6/9/2010 15:21:50.552'!
shouldCreateApplyCommands: aBoolean

	shouldCreateApplyCommands := aBoolean.
	self updateMethodWrappers: aBoolean.! !

!SyRepository methodsFor: 'repository' stamp: 'SR 6/1/2010 14:14:09.691'!
size

	^ objects size! !

!SyRepository methodsFor: 'repository' stamp: 'rkrk 6/2/2010 11:45:46.826'!
unregister: anObject

	objects removeAllSuchThat: [:regObject | regObject client == anObject].
	
	self shouldCreateApplyCommands ifTrue: [
		(objects contains: [:o | o client class == anObject class]) ifFalse: [
			instrumentor uninstrumentClass: (anObject class)]].! !

!SyRepository methodsFor: 'method wrappers' stamp: 'SR 6/1/2010 09:45:23.992'!
updateMethodWrappers: aBoolean

	aBoolean ifTrue: [
		"enable Method Wrappers for all classes".
		self all do: [ :o | instrumentor instrumentClass: (o class) ].
		
	] ifFalse: [
		"disable Method Wrappers for all classes."
		instrumentor uninstrumentAllAndReset.
	]! !

Object subclass: #SyServer
	instanceVariableNames: 'tcpServer repository mainProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Server'!

!SyServer commentStamp: 'SR 5/27/2010 12:19:26.044' prior: 0!
Extends a TCP server with some managed objects.

Idea: Maybe we should composite this with a tcp server and not inherit from that...

Example:

| server o1 o2 |
server := SySimpleServer new.
o1 := Person givenName: 'Micha' surname: 'Test'.
o2 := Person givenName: 'Christoph' surname: 'Muster'.
server
	register: o1;
	register: o2;
	start;
	inspect.!

!SyServer class methodsFor: 'defaults' stamp: 'mt 5/26/2010 12:59:10.538'!
defaultPort

	^ 22701! !

!SyServer methodsFor: 'signals' stamp: 'mt 6/13/2010 16:18:21.032'!
connectionsChanged

	self emitAlways.! !

!SyServer methodsFor: 'initialize-release' stamp: 'mt 6/15/2010 15:48:06.792'!
initialize

	super initialize.
	
	tcpServer := SyTcpServer new.
	self connect: tcpServer signal: #connectionsChanged toSelector: #connectionsChanged.

	repository := SyRepository new.
		
	tcpServer protocolProcessor: (SySimpleProtocolProcessor new
			objectMapping: (SyReferenceMapping foreward: repository forewardReferenceMappingBlock backward: repository backwardReferenceMappingBlock)).
	
	self startMainProcess.! !

!SyServer methodsFor: 'debugging' stamp: 'rkrk 6/2/2010 14:47:16.469'!
log: msg

	Transcript cr; show: msg asString.! !

!SyServer methodsFor: 'command handling' stamp: 'mt 6/15/2010 15:38:40.379'!
processIncomingCommands
	"See SySimpleProtocolProcessor>>pvtProcessCommand:senderID: for more infos."
	
	| array commandId command senderStream |
	array := tcpServer protocolProcessor nextCommand.

	commandId := array first.
	command := array second.
	senderStream := array third.
	
	self log: 'SyServer processing: ' , command asString.
	
	[
		| succeeded |
		succeeded := command execute: self repository.
		tcpServer protocolProcessor
			sendCommandResult: command
			with: commandId
			on: senderStream.
		succeeded & command class shouldBeReplicated ifTrue: [
			"Replicate the command if neccessary"
			self log: 'Server broadcasting: ' , command asString.
			tcpServer protocolProcessor
				sendCommandNonBlocking: command
				onAll: (tcpServer connections copyWithout: senderStream)]
	]
	on: SyClientClosedConnectionException
	do: [senderStream close].
	
! !

!SyServer methodsFor: 'initialize-release' stamp: 'SR 6/7/2010 10:07:38.069'!
release

	mainProcess ifNotNilDo: [:proc | proc terminate].
	self stop.
	
	super release.! !

!SyServer methodsFor: 'repository' stamp: 'SR 6/1/2010 10:28:57.017'!
repository

	^ repository! !

!SyServer methodsFor: 'start-stop' stamp: 'mt 5/31/2010 11:06:30.576'!
start

	tcpServer listenOn: self class defaultPort.! !

!SyServer methodsFor: 'command handling' stamp: 'mt 5/31/2010 09:20:45.756'!
startMainProcess
	"This process triggers the continous work of the server."
	
	mainProcess := [
		[self processIncomingCommands] repeat.
	] fork.! !

!SyServer methodsFor: 'start-stop' stamp: 'mt 5/31/2010 11:06:34.193'!
stop

	tcpServer close.! !

Object subclass: #SyTcpServer
	instanceVariableNames: 'listenSocket listenProcess connections connectionProcesses connectionChangesMonitor protocolProcessor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Server'!

!SyTcpServer commentStamp: 'mt 5/19/2010 12:50:32.652' prior: 0!
I am able to accept and manage incoming TCP connections.!

!SyTcpServer methodsFor: 'handling' stamp: 'mt 6/6/2010 14:29:46.207'!
close

	"Closing listen part"
	listenProcess ifNotNilDo: [:p | p terminate].
		
	"Closing connection part"
	self connectionProcesses do: [:proc | proc terminate].
	self connectionProcesses removeAll.
	
	! !

!SyTcpServer methodsFor: 'accessing - private' stamp: 'SR 5/10/2010 17:28:42.275'!
connectionProcesses

	^ connectionProcesses ifNil: [connectionProcesses := SySharedList new]! !

!SyTcpServer methodsFor: 'accessing - private' stamp: 'mt 5/9/2010 16:46:22.708'!
connections

	^ connections ifNil: [connections := SySharedList new]! !

!SyTcpServer methodsFor: 'signals' stamp: 'SR 6/3/2010 11:59:48.882'!
connectionsChanged

	self emit! !

!SyTcpServer methodsFor: 'testing' stamp: 'mt 5/9/2010 16:17:23.888'!
isListening

	^ self listenSocket isWaitingForConnection! !

!SyTcpServer methodsFor: 'listening' stamp: 'rkrk 5/14/2010 13:30'!
listenOn: aPort

	self isListening ifTrue: [self error: 'Server already listening!!'].
	self listenSocket listenOn: aPort backlogSize: 4.
	self startListenThread.! !

!SyTcpServer methodsFor: 'accessing - private' stamp: 'mt 5/9/2010 15:58:25.953'!
listenSocket

	^ listenSocket ifNil: [listenSocket := Socket newTCP]! !

!SyTcpServer methodsFor: 'listening' stamp: 'mt 5/29/2010 12:32:13.073'!
listenerProcessPriority

	^ Processor lowIOPriority! !

!SyTcpServer methodsFor: 'debugging' stamp: 'rkrk 5/14/2010 17:31'!
log: msg

	Transcript cr; show: msg asString.! !

!SyTcpServer methodsFor: 'handling' stamp: 'SR 6/3/2010 11:47:27.907'!
newConnectionOn: socket

	| con |
	con := SyTcpSocket on: socket.
	self connections add: con.
	self startConnectionThreadFor: con.
	
	self connectionsChanged.
! !

!SyTcpServer methodsFor: 'accessing' stamp: 'mt 5/9/2010 17:12:59.484'!
port

	^ self listenSocket port! !

!SyTcpServer methodsFor: 'accessing' stamp: 'mt 5/29/2010 10:32:05.82'!
protocolProcessor

	^ protocolProcessor! !

!SyTcpServer methodsFor: 'accessing' stamp: 'mt 5/26/2010 13:02:36.831'!
protocolProcessor: aProtocolProcessor

	protocolProcessor := aProtocolProcessor.! !

!SyTcpServer methodsFor: 'handling' stamp: 'SR 6/3/2010 11:48:12.249'!
startConnectionThreadFor: socket

	| connectionProcess |
	connectionProcess := [
		[[socket isConnected] whileTrue: [
				socket waitForDataIfClosed: [Processor activeProcess terminate].
				self protocolProcessor ifNotNilDo: [:p |
					(p processDataFrom: socket) ifFalse: [Processor activeProcess terminate]].
		]] ensure: [
			socket close.
			self connections remove: socket ifAbsent: [].
			self log: 'Some client socket closed'; log: socket debug.
			self connectionsChanged].
	] newProcess.
	self connectionProcesses add: connectionProcess.
	connectionProcess resume.! !

!SyTcpServer methodsFor: 'listening' stamp: 'mt 5/31/2010 08:01:17.378'!
startListenThread
	
	listenProcess := [
		[[self isListening] whileTrue: [
				(self listenSocket waitForAcceptFor: 3) ifNotNilDo: [:socket |
					self newConnectionOn: socket.
					self log: 'New client connected: ' , socket remoteAddress , ' ' , socket statusString]]
		] ensure: [
			self log: 'listener terminating, socket: ' , (listenSocket ifNotNilDo: [:s | s statusString]).
			listenSocket isValid ifTrue: [listenSocket closeAndDestroy].
			listenSocket := nil]
	] newProcess.

	listenProcess
		priority: self listenerProcessPriority;
		name: self class name, '''s listener process';
		resume.! !

SocketStream subclass: #SyTcpSocket
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tools'!

!SyTcpSocket class methodsFor: 'instance creation' stamp: 'mt 5/10/2010 11:05:32.461'!
connectToHost: nameOrAddressString port: anInteger
	
	^ self
		openConnectionToHostNamed: nameOrAddressString
		port: anInteger! !

!SyTcpSocket methodsFor: 'testing' stamp: 'SR 6/3/2010 14:18:00.28'!
isConnected
	"Fix socket bug under windows. Trigger a new receive operation to force status update in the plugin."
	
	[
		self adjustInBuffer: (self socket
			receiveDataNonBlockingInto: inBuffer
			startingAt: inNextToWrite).
		^ self socket isConnected]
	on: Exception
	do: [^ false]! !

!SyTcpSocket methodsFor: 'stream out' stamp: 'SR 6/3/2010 14:14:51.528'!
nextPutAll: aCollection
	"Overridden to be better testable with a normal stream. Use the optimized version #nextPutAllFlush:."
	
	^ self isConnected
		ifTrue: [self nextPutAllFlush: aCollection]
		ifFalse: [nil]! !

!SyTcpSocket methodsFor: 'accessing' stamp: 'mt 5/10/2010 11:23:48.023'!
remoteAddress

	^ self socket remoteAddress! !

!SyTcpSocket methodsFor: 'accessing' stamp: 'mt 5/30/2010 21:34:56.652'!
remoteAddressString

	^ NetNameResolver stringFromAddress: self socket remoteAddress! !

!SyTcpSocket methodsFor: 'accessing' stamp: 'mt 5/30/2010 21:36:39.6'!
remoteID

	^ self remoteAddressString, ':', self remotePort asString! !

!SyTcpSocket methodsFor: 'accessing' stamp: 'mt 5/10/2010 11:23:53.871'!
remotePort

	^ self socket remotePort! !

!SyTcpSocket methodsFor: 'waiting' stamp: 'mt 5/9/2010 17:23:15.848'!
waitForDataIfClosed: aBlock

	^ self socket waitForDataIfClosed: aBlock! !

!Socket methodsFor: '*SqSync' stamp: 'mt 5/31/2010 12:13:53.535'!
forceStatusUpdate
	"Workaround for broken Windows socket plugin. Better use SyTcpSocket where #isConnected will not loose any bytes if available."

	self
		receiveDataNonBlockingInto: ' '
		startingAt: 1.! !

!Socket methodsFor: '*SqSync' stamp: 'mt 5/31/2010 12:14:08.19'!
receiveDataNonBlockingInto: aStringOrByteArray startingAt: aNumber
	"To be used to fix the status bug under Windows."

	^ self primSocket: socketHandle
		receiveDataInto: aStringOrByteArray
		startingAt: aNumber
		count: aStringOrByteArray size - aNumber + 1! !

!BlockClosure methodsFor: '*SqSync' stamp: 'SR 6/7/2010 10:03:54.1'!
sqFork

	^ self sqForkAt: Processor activeProcess priority! !

!BlockClosure methodsFor: '*SqSync' stamp: 'SR 6/7/2010 10:03:33.432'!
sqForkAt: aPriorityInteger

	^ [
		Processor activeProcess priority: aPriorityInteger.
		self value] forkAt: 60! !

OrderedCollection subclass: #SySharedList
	instanceVariableNames: 'mutex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tools'!

!SySharedList commentStamp: 'mt 5/9/2010 17:04:27.753' prior: 0!
This is meant to be a thread-safe version of an OrderedCollection. See the "list" protocol to explore selectors which are thread-safe.!

!SySharedList methodsFor: 'list' stamp: 'mt 5/9/2010 16:52:24.122'!
add: anElement

	^ self mutex critical: [super add: anElement].! !

!SySharedList methodsFor: 'list' stamp: 'mt 5/31/2010 08:37:35.378'!
detect: aBlock ifNone: aNoneBlock

	^ self mutex critical: [super detect: aBlock ifNone: aNoneBlock]! !

!SySharedList methodsFor: 'accessing - private' stamp: 'mt 5/9/2010 16:40:52.25'!
mutex

	^ mutex ifNil: [mutex := Mutex new]! !

!SySharedList methodsFor: 'list' stamp: 'mt 5/9/2010 16:53:19.735'!
remove: anElement ifAbsent: aBlock
	"#remove: should also be guarded now."
	
	^ self mutex critical: [super remove: anElement ifAbsent: aBlock].! !

!SySharedList methodsFor: 'list' stamp: 'mt 5/30/2010 19:50:56.398'!
size

	^ self mutex critical: [super size]! !

MwMethodWrapper subclass: #SyMethodWrapper
	instanceVariableNames: 'instrumentor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Repository'!

!SyMethodWrapper class methodsFor: 'constants' stamp: 'SR 6/1/2010 10:07:33.141'!
notReplicatedSelectors

	^ {#=.}! !

!SyMethodWrapper class methodsFor: 'instance creation' stamp: 'SR 5/16/2010 17:18:44.185'!
on: aSymbol inClass: aClass for: anInstrumentor

	| wrapper |
	wrapper := self on: aSymbol inClass: aClass.
	wrapper instrumentor: anInstrumentor.
	^ wrapper! !

!SyMethodWrapper methodsFor: 'accessing' stamp: 'SR 5/16/2010 17:17:42.497'!
instrumentor

	^ instrumentor! !

!SyMethodWrapper methodsFor: 'accessing' stamp: 'SR 5/16/2010 17:17:39.016'!
instrumentor: anObject

	instrumentor := anObject! !

!SyMethodWrapper methodsFor: 'evaluating' stamp: 'rkrk 6/2/2010 20:47:28.979'!
isSelectorBanned

	^ SyMethodWrapper notReplicatedSelectors includes: self selector! !

!SyMethodWrapper methodsFor: 'evaluating' stamp: 'rkrk 6/2/2010 20:47:09.614'!
valueWithReceiver: anObject arguments: args

	| result |
	result := self clientMethod
		valueWithReceiver: anObject
		arguments: args.
	(self isSelectorBanned not and: [instrumentor notNil]) ifTrue: [
			instrumentor
				methodCalled: (self selector)
				on: anObject
				with: args
				resulting: result].
	^ result! !

TestCase subclass: #SyReferenceMappingStreamTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

SyReferenceMappingStreamTest class
	instanceVariableNames: 'sut'!

SyReferenceMappingStreamTest class
	instanceVariableNames: 'sut'!

!SyReferenceMappingStreamTest methodsFor: 'tests' stamp: 'mt 6/15/2010 15:35:20.283'!
test01UseBlockWhenSerializing

	| result sut |
	sut := SyReferenceMappingStream mapping: (SyReferenceMapping foreward: [:obj | 2]).
	sut nextPut: 1.
	sut reset.
	result := sut next.
	self assert: 2 equals: result.! !

!SyReferenceMappingStreamTest methodsFor: 'tests' stamp: 'mt 6/15/2010 15:35:46.328'!
test02CyclicMapping

	| result sut person |
	sut := SyReferenceMappingStream mapping: SyReferenceMapping identity.
	person := Person givenName: 'Peter' surname: 'Lustig'.
	person specialFriend: person.
	sut nextPut: person.
	sut reset.
	result := sut next.
	self assert: result == result specialFriend.
! !

!SyReferenceMappingStreamTest methodsFor: 'tests' stamp: 'mt 6/15/2010 15:34:38.361'!
test03ComplexMapping

	| result person1 person2 sut |
	sut := SyReferenceMappingStream mapping: (SyReferenceMapping foreward: [:obj |
		((obj isKindOf: Person) and: [obj givenName = 'Fritz'])
			ifTrue: [23]
			ifFalse: [obj]]).
	person1 := Person givenName: 'Peter' surname: 'Lustig'.
	person2 := Person givenName: 'Fritz' surname: 'Fuchs'.
	person1 specialFriend: person2.
	sut nextPut: person1.
	sut reset.
	result := sut next.
	self assert: 23 == result specialFriend.
! !

TestCase subclass: #SyTestCase
	instanceVariableNames: 'syClients'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

SyTestCase subclass: #SyClientTestCase
	instanceVariableNames: 'server sut obj1Server obj2Server obj1UUID obj2UUID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SyClientTestCase class methodsFor: 'as yet unclassified' stamp: 'SR 6/14/2010 18:56:49.554'!
defaultPort

	^ 22701! !

!SyClientTestCase methodsFor: 'running' stamp: 'SR 6/14/2010 18:50:46.508'!
setUp

	super setUp.
	server := SyServer new.
	obj1Server := Person givenName: 'Micha' surname: 'Test'.
	obj2Server := Person givenName: 'Christoph' surname: 'Muster'.
	obj1UUID := (server repository register: obj1Server) uuid.
	obj2UUID := (server repository register: obj2Server) uuid.
	server start.! !

!SyClientTestCase methodsFor: 'running' stamp: 'SR 6/14/2010 18:54:07.722'!
tearDown

	| errBlock |
	super tearDown.
	errBlock := [:e |
		Transcript cr;
			show: 'Error in tearDown of ' , self class , '>>#' , self selector;
			show: e].
	
	[server stop] on: Error do: errBlock.
	[server release] on: Error do: errBlock.
	server repository clear.! !

SyClientTestCase subclass: #SyClientTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SyClientTests methodsFor: 'testing' stamp: 'rkrk 6/2/2010 22:39:21.285'!
test01ConnectDisconnect

	sut := self createAndConnectClient.
	self assert: sut isConnected.
	sut disconnect.! !

!SyClientTests methodsFor: 'testing' stamp: 'rkrk 6/14/2010 01:10:54.352'!
test02GetObjects

	sut := self createAndConnectClient.
	self assert: sut isConnected.	
	self assert: (sut repository size = 2).
	self assert: (sut repository all contains: [:o | o = obj1Server]).
	self assert: (sut repository all contains: [:o | o = obj2Server]).! !

!SyClientTests methodsFor: 'testing' stamp: 'rkrk 6/14/2010 00:41:33.86'!
test03ServerAppliesClientOperation

	| objClient |
	sut := self createAndConnectClient.
	objClient := sut repository resolve: obj1UUID.
	objClient givenName: 'Hans'.
	self wait: 1.
	self assert: 'Hans' equals: obj1Server givenName.! !

!SyClientTests methodsFor: 'testing' stamp: 'rkrk 6/14/2010 00:40:20.642'!
test04OtherClientAppliesClientOperation

	| objClient1 objClient2 client1 client2 |
	client1 :=  self createAndConnectClient.
	client2 := self createAndConnectClient.

	objClient1 := client1 repository resolve: obj1UUID.
	objClient2 := client2 repository resolve: obj1UUID.
	
	objClient1 givenName: 'Hans'.
	
	self wait: 2.
	self assert: 'Hans' equals: objClient2 givenName.! !

!SyClientTests methodsFor: 'testing' stamp: 'mt 6/15/2010 16:01:41.085'!
test05VersionsAfterListCommand

	| obj ro roAtClient |
	"Register a new object and perform an operation."
	obj := Person givenName: 'Peter' surname: 'Klaus'.
	ro := server repository register: obj.
	(SyApplyCommand receiver: ro selector: #givenName: arguments: #(Micha))
		execute: server repository.

	"Create client, fetch object with list command and verify the version."
	sut := self createAndConnectClient.
	roAtClient := sut repository registeredObjectForUUID: ro uuid.

	self
		assert: 1 equals: roAtClient versionOffset;
		assert: 1 equals: roAtClient version.! !

!SyClientTests methodsFor: 'testing' stamp: 'mt 6/15/2010 16:01:41.155'!
test06BadVersionNotReplicated

	| objClient1 objClient2 client1 client2 regObjClient1 |
	client1 :=  self createAndConnectClient.
	client2 := self createAndConnectClient.

	objClient1 := client1 repository resolve: obj1UUID.
	objClient2 := client2 repository resolve: obj1UUID.
	
	regObjClient1 := client1 repository registeredObjectForUUID: obj1UUID.
	regObjClient1 versionOffset: 999. "Manipulate version."
	
	Transcript cr; show: 'SyClientTests>>#test06BadVersionNotReplicated - Client1 = ', client1 identityHash asString.
	
	
	"spy := SignalSpy onSender: server signal: #connectionsChanged."
	objClient1 givenName: 'Hans'.
	
	"spy waitForNextSignal." "Client 1 disconnected."
	"spy waitForNextSignal. ""Client 1 connected again."
	
	self wait: 2.
	
	self assert: 'Micha' equals: objClient2 givenName.
	
	"Check transscript for refused-message."
	Transcript cr; show: 'SyClientTests>>#test06BadVersionNotReplicated - Client1 = ', client1 identityHash asString, ' (rebooted)'.! !

!SyClientTests methodsFor: 'testing' stamp: 'rkrk 6/14/2010 01:58:46.062'!
test07DeferSends


	| client objClient |
	client :=  self createAndConnectClient.
	client deferSends.
	objClient := client repository resolve: obj1UUID.
	objClient givenName: 'Hans'.
	self wait: 1.
	self assert: 1 equals: client commandsNotYetSend size.
	self assert: 'Micha' equals: obj1Server givenName.
	client dontDeferSends.
	self wait: 1.
	self assert: 0 equals: client commandsNotYetSend size.
	self assert: 'Hans' equals: obj1Server givenName.! !

!SyClientTests methodsFor: 'testing' stamp: 'rkrk 6/14/2010 01:59:05.823'!
test08DeferSends

	"Acceptance test for Story 4 Task 2"

	| client1 client2 objClient1 objClient2 |
	client1 := self createAndConnectClient.
	client2 := self createAndConnectClient.
	objClient1 := client1 repository resolve: obj1UUID.
	objClient2 := client2 repository resolve: obj1UUID.
	
	client1 deferSends.
	objClient1 givenName: 'Hans'.	
	self wait: 1.
	self assert: 'Micha' equals: objClient2 givenName.

	objClient2 givenName: 'Fritz'. "conflict!!"
	self wait: 1.
	self assert: 'Fritz' equals: obj1Server givenName.
	self assert: 'Fritz' equals: objClient1 givenName.
	self assert: 0 equals: objClient1 commandsNotYetSend size.! !

SyClientTestCase subclass: #SyObjectReferenceTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SyObjectReferenceTests methodsFor: 'tests' stamp: 'SR 6/14/2010 19:03:11.274'!
test01PersonAddsSingleFriend

	| client obj1Client obj2Client |
	obj1Server specialFriend: obj2Server.
	client :=  self createAndConnectClient.
	obj1Client := client repository resolve: obj1UUID.
	obj2Client := client repository resolve: obj2UUID.
	self assert: obj1Client specialFriend == obj2Client.! !

!SyObjectReferenceTests methodsFor: 'tests' stamp: 'SR 6/14/2010 20:01:02.561'!
test02PersonWithFriendCollection

	| client obj1Client obj2Client obj3Server obj3UUID obj3Client |
	obj3Server := Person givenName: 'Robert' surname: 'Tester'.
	obj3Server
		addFriend: obj1Server;
		addFriend: obj2Server.
	obj3UUID := (server repository register: obj3Server) uuid.
	
	client :=  self createAndConnectClient.
	obj1Client := client repository resolve: obj1UUID.
	obj2Client := client repository resolve: obj2UUID.
	obj3Client := client repository resolve: obj3UUID.
	self assert: obj3Client friends size = 2.
	self assert: obj3Client friends first == obj1Client.
	self assert: obj3Client friends second == obj2Client.! !

!SyObjectReferenceTests methodsFor: 'tests' stamp: 'SR 6/14/2010 20:00:48.793'!
test03PersonWithCyclicFriendCollection

	| client obj1Client obj2Client |
	obj1Server addFriend: obj2Server.
	obj2Server addFriend: obj1Server.
		
	client :=  self createAndConnectClient.
	obj1Client := client repository resolve: obj1UUID.
	obj2Client := client repository resolve: obj2UUID.
	self assert: obj1Client friends first == obj2Client.
	self assert: obj2Client friends first == obj1Client.! !

!SyObjectReferenceTests methodsFor: 'tests' stamp: 'SR 6/14/2010 20:08:50.759'!
test04OperationWithComplexParameter

	| client1 client2 obj1Client1 obj2Client1 obj1Client2 obj2Client2 |
	client1 :=  self createAndConnectClient.
	client2 := self createAndConnectClient.

	obj1Client1 := client1 repository resolve: obj1UUID.
	obj2Client1 := client1 repository resolve: obj2UUID.
	
	obj1Client1 specialFriend: obj2Client1.
	
	obj1Client2 := client2 repository resolve: obj1UUID.
	obj2Client2 := client2 repository resolve: obj2UUID.
	
	self wait: 2.
	self assert: obj1Client2 specialFriend == obj2Client2! !

!SyObjectReferenceTests methodsFor: 'tests' stamp: 'SR 6/18/2010 16:01:10.315'!
test05OperationWithUnregisteredEntity

	| client1 client2 obj1Client1 obj1Client2 obj3UUID |
	client1 :=  self createAndConnectClient.
	client2 := self createAndConnectClient.

	obj1Client1 := client1 repository resolve: obj1UUID.
	
	obj1Client1 specialFriend: (Person givenName: 'Marcel' surname: 'Muster').
	
	obj1Client2 := client2 repository resolve: obj1UUID.
	
	self wait: 2.
	
	obj3UUID := (client1 repository registeredObjectForDomainObject: obj1Client1 specialFriend) uuid.
	self
		assert: (obj1Client1 specialFriend == (client1 repository resolve: obj3UUID));
		assert: obj1Client2 specialFriend notNil;
		assert: (obj1Client2 specialFriend == (client2 repository resolve: obj3UUID)).! !

SyTestCase subclass: #SyCommandsTest
	instanceVariableNames: 'repo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SyCommandsTest methodsFor: 'running' stamp: 'rkrk 6/10/2010 08:50:02.305'!
setUp

	super setUp.
	repo := SyRepository new.! !

!SyCommandsTest methodsFor: 'tests' stamp: 'mt 6/15/2010 15:24:44.145'!
test01CreateApplyCommand

	| sut obj regObj |
	obj := Person givenName: 'A' surname: 'B'.
	regObj := repo register: obj.
	sut := SyApplyCommand
		receiver: regObj
		selector: #givenName:
		arguments: #(C).

	self
		assert: #(C) equals: sut arguments;
		assert: regObj uuidString equals: sut receiverUUIDString;
		assert: #givenName: equals: sut selector.! !

!SyCommandsTest methodsFor: 'tests' stamp: 'mt 6/15/2010 15:24:51.25'!
test02ExecuteApplyCommand

	| sut obj regObj |
	obj := Person givenName: 'A' surname: 'B'.
	regObj := repo register: obj.
	sut := SyApplyCommand
		receiver: regObj
		selector: #givenName:
		arguments: #(C).
	sut execute: repo.
	self assert: 'C' equals: obj givenName.! !

!SyCommandsTest methodsFor: 'tests' stamp: 'mt 6/15/2010 15:24:59.884'!
test03ApplyCommandVersion

	| sut applyCommand regObj obj |
	obj := Person givenName: 'A' surname: 'B'.
	regObj := repo register: obj.
	applyCommand := SyApplyCommand
		receiver: regObj
		selector: #givenName:
		arguments: #(C).
		
	applyCommand execute: repo.

	"Create the real test object for this test."
	sut := SyApplyCommand
		receiver: regObj
		selector: #givenName:
		arguments: #(D).

	self
		assert: 0 equals: applyCommand expectedVersion;
		assert: 1 equals: sut expectedVersion.! !

!SyCommandsTest methodsFor: 'tests' stamp: 'mt 6/15/2010 15:25:07.291'!
test04ApplyCommandVersionMismatch

	| sut regObj obj |
	obj := Person givenName: 'A' surname: 'B'.
	regObj := repo register: obj.
	
	sut := (SyApplyCommand
		receiver: regObj
		selector: #givenName:
		arguments: #(C))
		expectedVersion: 999. "A new object should have 0 and not 999."
		
	self deny: (sut execute: repo).! !

!SyCommandsTest methodsFor: 'tests' stamp: 'mt 6/12/2010 19:12:54.003'!
test05ApplyCommandMissingObject

	| sut |
	sut := SyApplyCommand new
		receiverUUIDString: UUID new asString.
		
	self deny: (sut execute: repo).! !

!SyCommandsTest methodsFor: 'tests' stamp: 'mt 6/15/2010 15:25:17.847'!
test06ArgumentSerialisationTest

	| sut o1 regObj |
	o1 := Person givenName: 'Max' surname: 'Muster'.
	regObj := repo register: o1.
	
	sut := SyApplyCommand
		receiver: regObj
		selector: #givenName:
		arguments: #(C). 
	
	self assert: sut arguments = #(C).
	
	sut := SyApplyCommand
		receiver: regObj
		selector: #givenName:
		arguments: {o1.}.
	
	self assert: sut arguments first == o1.! !

SyTestCase subclass: #SyCommunicationModuleTest
	instanceVariableNames: 'tcpServer openClientSockets'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SyCommunicationModuleTest class methodsFor: 'helper' stamp: 'rkrk 5/14/2010 17:02'!
closeAllSockets

	Socket registry keys
		select: [:ea | ea isWaitingForConnection or: [ea isOtherEndClosed] or: [ea isConnected]]
		thenDo: [:ea | ea close].! !

!SyCommunicationModuleTest class methodsFor: 'constants' stamp: 'rkrk 5/14/2010 14:24'!
defaultPort

	^ 22701! !

!SyCommunicationModuleTest methodsFor: 'support' stamp: 'mt 6/6/2010 14:12:36.628'!
connectTCPClientToServer

	^ self connectTCPClientToServer: true! !

!SyCommunicationModuleTest methodsFor: 'support' stamp: 'mt 6/6/2010 14:17:35.823'!
connectTCPClientToServer: shouldBeBlocking

	| spy tcpSocket |
	tcpServer ifNotNilDo: [:server| spy := SignalSpy onSender: tcpServer signal: #connectionsChanged].
	
	tcpSocket := SyTcpSocket
		connectToHost: '127.0.0.1'
		port: self class defaultPort.
	
	(shouldBeBlocking and: [spy notNil]) ifTrue: [spy waitForNextSignal].
	openClientSockets add: tcpSocket.
	
	^ tcpSocket.! !

!SyCommunicationModuleTest methodsFor: 'support' stamp: 'mt 6/6/2010 14:21:46.429'!
disconnectTCPClientsFromServer

	| spy |
	tcpServer ifNotNilDo: [:server| spy := SignalSpy onSender: tcpServer signal: #connectionsChanged].
	openClientSockets do: [:ea | 
		ea isConnected ifTrue: [
			ea close.
			spy ifNotNilDo: [:s| s waitForNextSignal]]].! !

!SyCommunicationModuleTest methodsFor: 'running' stamp: 'SR 6/3/2010 14:06:07.673'!
setUp

	super setUp.
	openClientSockets := OrderedCollection new.
	Transcript cr; show: 'start '; show: self selector.! !

!SyCommunicationModuleTest methodsFor: 'support' stamp: 'SR 6/3/2010 14:11:29.696'!
startTcpServer

	tcpServer ifNil: [
		tcpServer := SyTcpServer new].
	tcpServer isListening
		ifFalse: [tcpServer listenOn: self class defaultPort].! !

!SyCommunicationModuleTest methodsFor: 'support' stamp: 'rkrk 5/26/2010 15:48:10.549'!
stopTcpServer

	tcpServer ifNotNil: [tcpServer close].! !

!SyCommunicationModuleTest methodsFor: 'running' stamp: 'rkrk 5/14/2010 18:15'!
tearDown

	super tearDown.
	Transcript cr; show: 'end '; show: self selector.
	[self
		disconnectTCPClientsFromServer;
		stopTcpServer
	] on: Error do: [:e | Transcript cr; show: 'Error in tearDown'; print: e].! !

!SyCommunicationModuleTest methodsFor: 'tests' stamp: 'rkrk 5/28/2010 00:50:34.851'!
test01TcpServerStartup

	| sut |
	sut := SyTcpServer new.
	
	self deny: sut isListening.
	
	[sut listenOn: self class defaultPort.
	self
		assert: sut isListening;
		assert: self class defaultPort equals: sut port;
		assert: sut connections isEmpty.
	] ensure: [sut close].! !

!SyCommunicationModuleTest methodsFor: 'tests' stamp: 'rkrk 5/28/2010 00:50:03.209'!
test02TcpServerShutdown
	
	self
		startTcpServer;
		assert: tcpServer isListening;
		stopTcpServer;
		deny: tcpServer isListening;
		assert: tcpServer connections isEmpty;
		assert: tcpServer connectionProcesses isEmpty;
		assert: (Socket registry keys noneSatisfy: [:socket | socket isWaitingForConnection]).! !

!SyCommunicationModuleTest methodsFor: 'tests' stamp: 'mt 6/6/2010 14:12:08.38'!
test03FailingTcpSocketConnection

	"try to connect to a server. This should either throw a ConnectionTimedOut error.
	Since we currently cannot control the timeout period of sockets and the default of 
	[Socket standardTimeout] = 45 is used we end the test earlier and just assume
	that the connection can't be established."
	<timeout: 3> "1s more than needed"
	| connectionFailed connectReturned connectProcess |
	connectionFailed := false.
	connectReturned := false.
	connectProcess := [
		[self connectTCPClientToServer: false. connectReturned := true]
			on: ConnectionTimedOut
			do: [connectionFailed := true]] fork.
	self wait: 2. "seconds"
	connectProcess terminate.
	connectionFailed ifTrue: [^self].
	connectReturned ifTrue: [^self]. "assume it works"
	self
		assert: false
		description: '#connectTCPClientToServer was successful although no server was started!!'.! !

!SyCommunicationModuleTest methodsFor: 'tests' stamp: 'mt 6/6/2010 14:18:50.298'!
test04TcpSocketConnection

	| tcpSocket |
	self startTcpServer.
	tcpSocket := self connectTCPClientToServer.
	self
		assert: tcpSocket isConnected description: 'tcp socket not connected';
		assert: 1 equals: tcpServer connectionProcesses size.! !

!SyCommunicationModuleTest methodsFor: 'tests' stamp: 'mt 6/6/2010 14:12:51.446'!
test05TcpServerIncomingConnections

	self
		startTcpServer;
		assert: tcpServer connections isEmpty;
		connectTCPClientToServer;
		assert: tcpServer connections size = 1;
		connectTCPClientToServer;
		assert: tcpServer connections size = 2;
		disconnectTCPClientsFromServer;
		assert: tcpServer connections isEmpty.! !

SyTestCase subclass: #SyProcessBugTest
	instanceVariableNames: 'process'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SyProcessBugTest methodsFor: 'as yet unclassified' stamp: 'mt 6/9/2010 15:56:30.19'!
tearDown

	super tearDown.
	process ifNotNilDo: [:p | p terminate]! !

!SyProcessBugTest methodsFor: 'as yet unclassified' stamp: 'mt 6/9/2010 15:56:54.556'!
test01Termination

	process := [[1+1] repeat ] sqForkAt: 35.
	process suspend.
	process terminate.
	
	self assert: process isTerminated.! !

!SyProcessBugTest methodsFor: 'as yet unclassified' stamp: 'mt 6/9/2010 16:00:08.618'!
test02FailedTermination

	process := [[1+1] repeat ] forkAt: 35.
	process suspend.
	process terminate.
	
	self deny: process isTerminated.
	
	[process priority: 60; resume.
	Processor yield.
	process terminate] forkAt: 60.

	self assert: process isTerminated.! !

SyTestCase subclass: #SyRepositoryTests
	instanceVariableNames: 'sut o1 o2 applyCommand'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SyRepositoryTests methodsFor: 'running' stamp: 'SR 6/1/2010 09:39:19.875'!
setUp

	super setUp.
	
	sut := SyRepository new.
	o1 := Person givenName: 'Micha' surname: 'Test'.
	o2 := Person givenName: 'Christoph' surname: 'Muster'.! !

!SyRepositoryTests methodsFor: 'running' stamp: 'mt 6/9/2010 15:41:36.535'!
tearDown

	"Unregister method wrappers."
	sut shouldCreateApplyCommands: false.
	applyCommand := nil.
	
	^ super tearDown ! !

!SyRepositoryTests methodsFor: 'testing' stamp: 'SR 6/1/2010 09:42:02.101'!
test01UnRegisterObject

	self assert: sut isEmpty.
	sut register: o1.
	self assert: sut all size = 1.
	sut unregister: o1.
	self assert: sut isEmpty.! !

!SyRepositoryTests methodsFor: 'testing' stamp: 'SR 6/1/2010 09:55:42.994'!
test02DoubleRegistration

	self assert: sut isEmpty.
	sut register: o1.
	self assert: sut all size = 1.
	
	self
		should: [sut register: o1]
		raise: Exception.
! !

!SyRepositoryTests methodsFor: 'testing' stamp: 'rkrk 6/13/2010 23:48:36.099'!
test03UnWrapObject

	self deny: (o1 class methodDict values first isMwMethodWrapper).
	sut shouldCreateApplyCommands: true.
	sut dontCreateApplyCommandsDuring: [
		sut register: o1.
		self deny: (o1 class methodDict values first isMwMethodWrapper)].
	self assert: (o1 class methodDict values first isMwMethodWrapper).
	sut unregister: o1.
	self deny: (o1 class methodDict values first isMwMethodWrapper).! !

!SyRepositoryTests methodsFor: 'testing' stamp: 'mt 6/9/2010 15:42:43.24'!
test04ApplyCommandCreation

	| ro1 |
	sut shouldCreateApplyCommands: true.
	ro1 := sut register: o1.
	sut addDependent: self.
	
	o1 givenName: 'Peter'.
	self
		assert: ro1 uuid equals: applyCommand receiverUUID;
		assert: #givenName: equals: applyCommand selector.! !

!SyRepositoryTests methodsFor: 'testing' stamp: 'mt 6/15/2010 15:23:51.961'!
test05OperationStackTest

	| ro1 |
	sut shouldCreateApplyCommands: true.
	ro1 := sut register: o1.
	sut addDependent: self. "Catch apply commands in this object."
	
	self assert: ro1 operations isEmpty.
	
	o1 givenName: 'Siegbert'. "Create apply command."
	
	self assert: 0 equals: ro1 version.
		
	self
		assert: (applyCommand execute: sut); "Execute command on repository."
		assert: 1 equals: ro1 version;
		assert: ro1 version equals: ro1 operations size;
		assert: #givenName: equals: ro1 operations last selector;
		assert: {'Siegbert'} equals: ro1 operations last arguments.! !

!SyRepositoryTests methodsFor: 'testing' stamp: 'SR 6/14/2010 18:43:17.76'!
test06RootObjectTest

	self assert: sut rootObject = nil.
	sut rootObject: o1.
	self assert: sut rootObject = o1	! !

!SyRepositoryTests methodsFor: 'support' stamp: 'SR 6/1/2010 10:22:24.996'!
update: anAspect with: aParameter

	(anAspect = #operation) ifTrue: [ applyCommand := aParameter ].
	super update: anAspect with: aParameter.! !

SyTestCase subclass: #SySimpleProtocolProcessorTest
	instanceVariableNames: 'sut o1 stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SySimpleProtocolProcessorTest methodsFor: 'support' stamp: 'mt 5/30/2010 21:10:42.257'!
clearStream

	stream := ReadWriteStream on: ''.! !

!SySimpleProtocolProcessorTest methodsFor: 'support' stamp: 'mt 5/30/2010 21:18:41.14'!
resetStream

	stream reset.! !

!SySimpleProtocolProcessorTest methodsFor: 'running' stamp: 'mt 5/30/2010 20:46:11.522'!
setUp

	super setUp.
	sut := SySimpleProtocolProcessor new.
	o1 := Dictionary newFrom: {
		#tag -> 'uuid'.
		#value -> UUID new asString}.
	self clearStream.! !

!SySimpleProtocolProcessorTest methodsFor: 'testing' stamp: 'mt 6/15/2010 15:36:59.508'!
test01Serialization

	| serialized deserialized |
	sut objectMapping: SyReferenceMapping identity.
	serialized := sut serialize: o1 withMapping: false.
	deserialized := sut deserialize: serialized withMapping: false.
	self assert: deserialized = o1.! !

!SySimpleProtocolProcessorTest methodsFor: 'testing' stamp: 'SR 6/14/2010 19:36:16.865'!
test02SendingReceivingCommands

	| command process result nextCommand |

	command := SyQuitCommand new.
			
	process := [
		result := sut sendCommandBlocking: command on: stream.
	] forkAt: 60.
	
	self resetStream.
	sut processDataFrom: stream.
	
	nextCommand := sut nextCommand.
	self assert: {0. command. stream.} equals: nextCommand.
	
	self clearStream.
	sut 
		sendCommandResult: nextCommand second
		with: nextCommand first
		on: stream.
	
	self resetStream.
	sut processDataFrom: stream.
	
	Processor yield. "Let the result variable be set."

	self
		assert: (nextCommand second) equals: result;
		assert: process isTerminated.! !

SyTestCase subclass: #SySocketBugTest
	instanceVariableNames: 's1 s2 s3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SySocketBugTest methodsFor: 'running' stamp: 'rkrk 5/29/2010 11:56:47.535'!
tearDown

	super tearDown.
	s1 closeAndDestroy.
	s2 closeAndDestroy.
	s3 closeAndDestroy.! !

!SySocketBugTest methodsFor: 'testing' stamp: 'mt 5/31/2010 12:00:17.802'!
test01AutoDisconnection

	s1 := Socket newTCP.
	s2 := Socket newTCP.
	s1 listenOn: 12345.
	s3 := s2 connectToHostNamed: 'localhost' port:  12345.
	s1 waitForConnectionFor: 5.
	s2 waitForConnectionFor: 5.
	self
		assert: s1 isConnected;
		assert: s2 isConnected;
		assert: s3 == s2.

	s2 closeAndDestroy.
	s1 forceStatusUpdate.
		
	self
		deny: s2 isConnected;
		deny: s1 isConnected.! !

!SySocketBugTest methodsFor: 'testing' stamp: 'mt 5/31/2010 12:00:23.284'!
test02AutoDisconnectionWithServer

	s1 := Socket newTCP.
	s2 := Socket newTCP.
	s1 listenOn: 12345 backlogSize: 4.
	s2 connectToHostNamed: 'localhost' port:  12345.
	s3 := s1 waitForAcceptFor: 5.
	s2 waitForConnectionFor: 5.
	
	self
		deny: s1 isConnected;
		assert: s2 isConnected;
		assert: s3 isConnected.

	s2 closeAndDestroy.
	s3 forceStatusUpdate.
		
	self
		deny: s1 isConnected;
		deny: s2 isConnected;
		deny: s3 isConnected.! !

!SySocketBugTest methodsFor: 'testing' stamp: 'mt 5/31/2010 13:37:50.642'!
test03StreamWorkaround
	"Check whether the workaround discards no data unexpectedly."

	| stream1 stream2 |
	
	s1 := Socket newTCP.
	s2 := Socket newTCP.
	s1 listenOn: 12345.
	s3 := s2 connectToHostNamed: 'localhost' port:  12345.
	s1 waitForConnectionFor: 5.
	s2 waitForConnectionFor: 5.
	
	stream1 := SyTcpSocket on: s1.
	stream2 := SyTcpSocket on: s2.
	
	stream1 nextPutAll: 'Hello!!'.
	stream2 isConnected. "This contains the workaround."
	
	self assert: 'Hello' equals: (stream2 upToAll: '!!').
! !

!SyTestCase methodsFor: 'support' stamp: 'rkrk 6/2/2010 22:35:45.655'!
createAndConnectClient

	| cl |
	cl := SyClient new
		connectToHostNamed: 'localhost'
		port: self class defaultPort.
	syClients add: cl.
	^ cl.! !

!SyTestCase methodsFor: 'running' stamp: 'rkrk 6/2/2010 22:36:46.804'!
setUp

	super setUp.
	syClients := OrderedCollection new.! !

!SyTestCase methodsFor: 'running' stamp: 'rkrk 6/2/2010 22:38:01.013'!
tearDown

	super tearDown.
	syClients do: [:ea | ea disconnect].! !

!SyTestCase methodsFor: 'support' stamp: 'rkrk 6/2/2010 21:58:27.696'!
wait: seconds

	(Delay forSeconds: seconds) wait.! !

!Process methodsFor: '*SqSync' stamp: 'rkrk 6/13/2010 23:42:16.755'!
isNilOrTerminated

	^ self isTerminated! !
